VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements core.IBasePlugin

Private Declare Function PaintDesktop Lib "USER32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal iCapabilitiy As Long) As Long
Private Declare Function GetSystemPaletteEntries Lib "gdi32" (ByVal hdc As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
Private Declare Function CreatePalette Lib "gdi32" (lpLogPalette As LOGPALETTE) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDCDest As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hDCSrc As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetForegroundWindow Lib "USER32" () As Long
Private Declare Function SelectPalette Lib "gdi32" (ByVal hdc As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Private Declare Function RealizePalette Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetWindowDC Lib "USER32" (ByVal hwnd As Long) As Long
Private Declare Function GetDC Lib "USER32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowRect Lib "USER32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function ReleaseDC Lib "USER32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function GetDesktopWindow Lib "USER32" () As Long
Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long

Public Type Info
    CompanyName As String
    FileDescription As String
    LegalCopyright As String
    ProductName As String
    FileVersion As String
    ProductVersion As String
    InternalName As String
    OriginalFilename As String
End Type

Private Type PALETTEENTRY
   peRed As Byte
   peGreen As Byte
   peBlue As Byte
   peFlags As Byte
End Type

Private Type LOGPALETTE
   palVersion As Integer
   palNumEntries As Integer
   palPalEntry(255) As PALETTEENTRY  ' Enough for 256 colors.
End Type

Private Type GUID
   Data1 As Long
   Data2 As Integer
   Data3 As Integer
   Data4(7) As Byte
End Type

Const RASTERCAPS As Long = 38
Const RC_PALETTE As Long = &H100
Const SIZEPALETTE As Long = 104

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Type PicBmp
   Size As Long
   Type As Long
   hBmp As Long
   hPal As Long
   Reserved As Long
End Type

Private m_cDib As New cDIBSection
Private m_sName As String

Private Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)
Private Declare Sub GetSystemInfo Lib "kernel32" (lpSystemInfo As SYSTEM_INFO)
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

'Flags for GetSystemInfo
Private Const PROCESSOR_INTEL_386 As Long = 386
Private Const PROCESSOR_INTEL_486 As Long = 486
Private Const PROCESSOR_INTEL_PENTIUM As Long = 586
Private Const PROCESSOR_MIPS_R4000 As Long = 4000
Private Const PROCESSOR_ALPHA_21064 As Long = 21064
Private Const PROCESSOR_PPC_601 As Long = 601
Private Const PROCESSOR_PPC_603 As Long = 603
Private Const PROCESSOR_PPC_604 As Long = 604
Private Const PROCESSOR_PPC_620 As Long = 620
Private Const PROCESSOR_HITACHI_SH3 As Long = 10003    'Windows CE
Private Const PROCESSOR_HITACHI_SH3E As Long = 10004   'Windows CE
Private Const PROCESSOR_HITACHI_SH4 As Long = 10005    'Windows CE
Private Const PROCESSOR_MOTOROLA_821 As Long = 821     'Windows CE
Private Const PROCESSOR_SHx_SH3 As Long = 103          'Windows CE
Private Const PROCESSOR_SHx_SH4 As Long = 104          'Windows CE
Private Const PROCESSOR_STRONGARM As Long = 2577       'Windows CE - 0xA11
Private Const PROCESSOR_ARM720 As Long = 1824          'Windows CE - 0x720
Private Const PROCESSOR_ARM820 As Long = 2080          'Windows CE - 0x820
Private Const PROCESSOR_ARM920 As Long = 2336          'Windows CE - 0x920
Private Const PROCESSOR_ARM_7TDMI As Long = 70001      'Windows CE

Private Const PROCESSOR_ARCHITECTURE_INTEL As Long = 0
Private Const PROCESSOR_ARCHITECTURE_MIPS As Long = 1
Private Const PROCESSOR_ARCHITECTURE_ALPHA As Long = 2
Private Const PROCESSOR_ARCHITECTURE_PPC As Long = 3
Private Const PROCESSOR_ARCHITECTURE_SHX As Long = 4
Private Const PROCESSOR_ARCHITECTURE_ARM As Long = 5
Private Const PROCESSOR_ARCHITECTURE_IA64 As Long = 6
Private Const PROCESSOR_ARCHITECTURE_ALPHA64 As Long = 7
Private Const PROCESSOR_ARCHITECTURE_UNKNOWN   As Long = &HFFFF

Private Const PROCESSOR_LEVEL_80386 As Long = 3
Private Const PROCESSOR_LEVEL_80486 As Long = 4
Private Const PROCESSOR_LEVEL_PENTIUM As Long = 5
Private Const PROCESSOR_LEVEL_PENTIUMII As Long = 6

Private Const sCPURegKey = "HARDWARE\DESCRIPTION\System\CentralProcessor\0"

Private Const HKEY_LOCAL_MACHINE As Long = &H80000002

Private Type SYSTEM_INFO
   dwOemID As Long
   dwPageSize As Long
   lpMinimumApplicationAddress As Long
   lpMaximumApplicationAddress As Long
   dwActiveProcessorMask As Long
   dwNumberOfProcessors As Long
   dwProcessorType As Long
   dwAllocationGranularity As Long
   wProcessorLevel As Integer
   wProcessorRevision As Integer
End Type

Private Type MEMORYSTATUS
    dwLength As Long
    dwMemoryLoad As Long
    dwTotalPhys As Long
    dwAvailPhys As Long
    dwTotalPageFile As Long
    dwAvailPageFile As Long
    dwTotalVirtual As Long
    dwAvailVirtual As Long
End Type

Const VER_PLATFORM_WIN32s = 0
Const VER_PLATFORM_WIN32_WINDOWS = 1
Const VER_PLATFORM_WIN32_NT = 2

'windows-defined type OSVERSIONINFO
Private Type OSVERSIONINFO
  OSVSize         As Long         'size, in bytes, of this data structure
  dwVerMajor      As Long         'ie NT 3.51, dwVerMajor = 3; NT 4.0, dwVerMajor = 4.
  dwVerMinor      As Long         'ie NT 3.51, dwVerMinor = 51; NT 4.0, dwVerMinor= 0.
  dwBuildNumber   As Long         'NT: build number of the OS
                                  'Win9x: build number of the OS in low-order word.
                                  '       High-order word contains major & minor ver nos.
  PlatformID      As Long         'Identifies the operating system platform.
  szCSDVersion    As String * 128 'NT: string, such as "Service Pack 3"
                                  'Win9x: 'arbitrary additional information'
End Type

Const coreUrl = "www.coreshell.info"
Const nkb As Long = 1024
Dim oserver As core.CServer
Private Function IBasePlugin_StartPlugin(Name As String) As Long
    
    If App.PrevInstance Then
       Exit Function
    End If
    
    Dim textline As String
    Dim doneFirst As Boolean
    
    m_sName = Name
    
    Set oserver = CreateObject("core.CServer")
    oserver.RegisterBang Name, "!update"
    
End Function
Private Sub IBasePlugin_StopPlugin()

End Sub
Private Sub IBasePlugin_Bang(ByVal Name As String, ByVal Arguments As String)

    
    Select Case Name
    Case "!update"
        Call update
    End Select
   
End Sub
Private Function CreateBitmapPicture(ByVal hBmp As Long, ByVal hPal As Long) As Picture

    Dim r As Long
    Dim Pic As PicBmp
    Dim IPic As IPicture
    Dim IID_IDispatch As GUID

    ' Fill in with IDispatch Interface ID.
    With IID_IDispatch
       .Data1 = &H20400
       .Data4(0) = &HC0
       .Data4(7) = &H46
    End With
    
    ' Fill Pic with necessary parts.
    With Pic
       .Size = Len(Pic)          ' Length of structure.
       .Type = vbPicTypeBitmap   ' Type of Picture (bitmap).
       .hBmp = hBmp              ' Handle to bitmap.
       .hPal = hPal              ' Handle to palette (may be null).
    End With
    
    ' Create Picture object.
    r = OleCreatePictureIndirect(Pic, IID_IDispatch, 1, IPic)
    
    ' Return the new Picture object.
    Set CreateBitmapPicture = IPic

End Function
Private Function CaptureWindow(ByVal hWndSrc As Long, ByVal Client As Boolean, ByVal LeftSrc As Long, ByVal TopSrc As Long, ByVal WidthSrc As Long, ByVal HeightSrc As Long) As Picture

    Dim hDCMemory As Long
    Dim hBmp As Long
    Dim hBmpPrev As Long
    Dim r As Long
    Dim hDCSrc As Long
    Dim hPal As Long
    Dim hPalPrev As Long
    Dim RasterCapsScrn As Long
    Dim HasPaletteScrn As Long
    Dim PaletteSizeScrn As Long
    Dim LogPal As LOGPALETTE

    ' Depending on the value of Client get the proper device context.
    If Client Then
        hDCSrc = GetDC(hWndSrc) ' Get device context for client area.
    Else
        hDCSrc = GetWindowDC(hWndSrc) ' Get device context for entire window.
    End If

    ' Create a memory device context for the copy process.
    hDCMemory = CreateCompatibleDC(hDCSrc)
    ' Create a bitmap and place it in the memory DC.
    hBmp = CreateCompatibleBitmap(hDCSrc, WidthSrc, HeightSrc)
    hBmpPrev = SelectObject(hDCMemory, hBmp)

    ' Get screen properties.
    RasterCapsScrn = GetDeviceCaps(hDCSrc, RASTERCAPS) ' Raster capabilities.
    HasPaletteScrn = RasterCapsScrn And RC_PALETTE       ' Palette support.
    PaletteSizeScrn = GetDeviceCaps(hDCSrc, SIZEPALETTE) ' Size of palette.

    ' If the screen has a palette make a copy and realize it.
    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        ' Create a copy of the system palette.
        LogPal.palVersion = &H300
        LogPal.palNumEntries = 256
        r = GetSystemPaletteEntries(hDCSrc, 0, 256, LogPal.palPalEntry(0))
        hPal = CreatePalette(LogPal)
        ' Select the new palette into the memory DC and realize it.
        hPalPrev = SelectPalette(hDCMemory, hPal, 0)
        r = RealizePalette(hDCMemory)
    End If

    ' Copy the on-screen image into the memory DC.
    r = BitBlt(hDCMemory, 0, 0, WidthSrc, HeightSrc, hDCSrc, LeftSrc, TopSrc, vbSrcCopy)

    ' Remove the new copy of the  on-screen image.
    hBmp = SelectObject(hDCMemory, hBmpPrev) '

    ' If the screen has a palette get back the palette that was
    ' selected in previously.
    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        hPal = SelectPalette(hDCMemory, hPalPrev, 0)
    End If
    
    ' Release the device context resources back to the system.
    r = DeleteDC(hDCMemory)
    r = ReleaseDC(hWndSrc, hDCSrc)
    
    Set CaptureWindow = CreateBitmapPicture(hBmp, hPal)

End Function
Private Function CaptureScreen() As Picture
    
    Dim hWndScreen As Long
    
    hWndScreen = GetDesktopWindow()
    Set CaptureScreen = CaptureWindow(hWndScreen, False, 0, 0, Screen.Width / Screen.TwipsPerPixelX, Screen.Height / Screen.TwipsPerPixelY)

End Function
Private Function getCPU() As String

    Dim SI As SYSTEM_INFO
    Dim tmp As String
    Dim temp As String
    
    Call GetSystemInfo(SI)
    
    temp = SI.dwNumberOfProcessors & " "
    
    Select Case SI.wProcessorLevel
       Case PROCESSOR_LEVEL_80386: tmp = "Intel 80386"
       Case PROCESSOR_LEVEL_80486: tmp = "Intel 80486"
       Case PROCESSOR_LEVEL_PENTIUM: tmp = "Intel Pentium"
       Case PROCESSOR_LEVEL_PENTIUMII: tmp = "Intel Pentium Pro or Pentium II"
    End Select
    
    getCPU = temp & tmp & " at " & GetCPUSpeed() & " MHz"
   
End Function
Private Function GetCPUSpeed() As Long
   
   Dim hKey As Long
   Dim cpuSpeed As Long
    
  'Open CPU key
   Call RegOpenKey(HKEY_LOCAL_MACHINE, sCPURegKey, hKey)
                    
  'and retrieve the value
   Call RegQueryValueEx(hKey, "~MHz", 0, 0, cpuSpeed, 4)
   Call RegCloseKey(hKey)
    
   GetCPUSpeed = cpuSpeed

End Function
Public Function GetOS() As String

   Dim OSV As OSVERSIONINFO
   Dim r As Long
   Dim pos As Integer
   Dim sVer As String
   Dim sBuild As String
   
   OSV.OSVSize = Len(OSV)
   
   If GetVersionEx(OSV) = 1 Then
   
     'PlatformId contains a value representing the OS
      Select Case OSV.PlatformID
         Case VER_PLATFORM_WIN32s: GetOS = "32s"
         Case VER_PLATFORM_WIN32_NT:
                   
           'dwVerMajor = NT version.
           'dwVerMinor = minor version
            Select Case OSV.dwVerMajor
               Case 3:
               
                  Select Case OSV.dwVerMinor
                     Case 0:  GetOS = "Windows NT3"
                     Case 1:  GetOS = "Windows NT3.1"
                     Case 5:  GetOS = "Windows NT3.5"
                     Case 51: GetOS = "Windows NT3.51"
                  End Select
            
               Case 4: GetOS = "Windows NT4"
               Case 5: GetOS = "Windows 2000"
            End Select
         
         Case VER_PLATFORM_WIN32_WINDOWS:
         
           'dwVerMinor bit tells if its 95 or 98.
            Select Case OSV.dwVerMinor
               Case 0:    GetOS = "Windows 95"
               Case Else: GetOS = "Windows 98"
            End Select
         
      End Select
   
   End If

End Function
Private Sub update()
        
    Dim SI As String
'    Dim c As New cDIBSection
    Dim I As Long
    Dim j As Long
    Dim tUser As String
    Dim tPass As String
    Dim tStr As String
    Dim sections() As String
    Dim mods() As core.IBasePlugin
    Dim done() As String
    Dim found As Boolean
    Dim ret As String
    Dim url As String
    
    oserver.Execute "!log Updating userprofile on the core website"
    url = oserver.GetKey(m_sName, "url")
    If url = "" Then url = coreUrl
    
    tUser = oserver.GetKey(m_sName, "user")
    If tUser = "" Then
        oserver.Execute "!log Couldn't find username, requesting"
        tUser = InputBox("Please enter your username:", "Username", "")
    End If
    tPass = oserver.GetKey(m_sName, "pass")
    If tPass = "" Then
        oserver.Execute "!log Couldn't find password, requesting"
        tPass = InputBox("Please enter your password:", "Password", "")
    End If
    If PostInfo(url, "/users.php3", "action=verify&user=" & tUser & "&pass=" & tPass) <> "ok" Then
        oserver.Execute "!Log Error: You dont have an account on the core website or the username/password that you have supplied are wrong. Please register or check you settings before running the program again."
    Else
        If oserver.evalBool(oserver.GetKey(m_sName, "modules")) Then
            
            oserver.Execute "!log Updating loaded modules"
            ReDim done(0)
            
            ret = PostInfo(url, "/users.php3", "action=clearmods&user=" & tUser & "&pass=" & tPass)
            If ret <> "ok" Then
                oserver.Execute "!Log Error: Failed to clear the  module settings"
            End If
            
            mods = oserver.LoadedPlugins
            For I = 1 To UBound(mods)
                found = False
                For j = 1 To UBound(done)
                    If mods(I).PluginName = done(j) Then
                        found = True
                        Exit For
                    End If
                Next j
                If Not found Then
                    ReDim Preserve done(UBound(done) + 1)
                    done(UBound(done)) = mods(I).PluginName
                    tStr = "&name=" & Replace(mods(I).PluginName, " ", "%20")
                    tStr = tStr & "&version=" & Replace(mods(I).Version, " ", "%20")
                    ret = PostInfo(url, "/users.php3", "action=addmod&user=" & tUser & "&pass=" & tPass & tStr)
                    If ret <> "ok" Then
                        oserver.Execute "!Log Error: Failed to update system settings (" & ret & ")"
                    End If
                End If
                DoEvents
            Next I
        End If
        
        If oserver.evalBool(oserver.GetKey(m_sName, "system")) Then
            oserver.Execute "!log Updating system setup"
            tStr = "&cpu=" & getCPU & "&os=" & GetOS & "&core=" & oserver.Version
            tStr = Replace(tStr, " ", "%20")
            ret = PostInfo(url, "/users.php3", "action=addsys&user=" & tUser & "&pass=" & tPass & tStr)
            If ret <> "ok" Then
                oserver.Execute "!Log Error: Failed to update system settings (" & ret & ")"
            End If
            DoEvents
        End If
        
        
        If oserver.evalBool(oserver.GetKey(m_sName, "screenshot")) Then
            oserver.Execute "!log Updating screenshot"
            frmMain.Picture = CaptureScreen()
            Set m_cDib = New cDIBSection
            m_cDib.CreateFromPicture frmMain.Picture
            SI = App.Path & "\users.jpg"
            If Not SaveJPG(m_cDib, SI) Then
                oserver.Execute "Error: Failed to save the picture to the file: '" & SI & "'"
            Else
                
                Dim strImage As String
                Dim strBody As String
                Dim aPostData() As Byte
                Dim nFile As Integer
                
'                Dim strFileName As String
                Dim oHttp As XMLHTTPRequest
    
                'make use of the XMLHTTPRequest object contained in msxml.dll
                Set oHttp = New XMLHTTPRequest
                
                'read the JPEG file
                nFile = FreeFile
                Open App.Path & "\users.jpg" For Binary As #nFile
                strImage = String(LOF(nFile), " ")
                Get #nFile, , strImage
                Close #nFile
                
                'fire of an http request
                oHttp.open "POST", "http://" & url & "/upload.php3", False
                oHttp.setRequestHeader "Content-Type", "multipart/form-data, boundary=AaB03x"
                'assemble the body. send one field and one file

               strBody = _
                   "--AaB03x" & vbCrLf & _
                   "Content-Disposition: form-data; name=""user""" & vbCrLf & vbCrLf & tUser & vbCrLf & _
                   "--AaB03x" & vbCrLf & _
                   "Content-Disposition: form-data; name=""pass""" & vbCrLf & vbCrLf & tPass & vbCrLf & _
                   "--AaB03x" & vbCrLf & _
                    "Content-Disposition: form-data; name=""userfile""; filename=""" & App.Path & "\users.jpg""" & vbCrLf & _
                   "Content-Transfer-Encoding: binary" & vbCrLf & _
                   "Content-Type: image/pjpeg" & vbCrLf & _
                   vbCrLf & _
                   strImage & vbCrLf & _
                   "--AaB03x--"
                
                'must convert to byte array because of binary zeros
                aPostData = StrConv(strBody, vbFromUnicode)
                'send it
                oHttp.send aPostData
                'check the feedback
                oserver.Execute "!log " & oHttp.responseText
            End If
            Kill SI
            DoEvents
        End If
    End If
    oserver.Execute "!log Done updating user information"

End Sub
Public Property Get IBasePlugin_InstanceName() As String

    IBasePlugin_InstanceName = m_sName

End Property
Public Property Get IBasePlugin_PluginName() As String

    IBasePlugin_PluginName = App.Title

End Property
Public Property Get IBasePlugin_Copyright() As String

    IBasePlugin_Copyright = App.LegalCopyright

End Property
Public Property Get IBasePlugin_Version() As String

    IBasePlugin_Version = App.Major & "." & App.Minor

End Property
Public Property Get IBasePlugin_Description() As String

    IBasePlugin_Description = App.FileDescription

End Property
